'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.asset = asset;
exports.request = request;

exports.default = function (file) {
  var options = arguments.length <= 1 || arguments[1] === undefined ? {
    root: (0, _path.dirname)(file)
  } : arguments[1];

  var stats = JSON.parse((0, _fs.readFileSync)(file));
  return (0, _flowRight2.default)(request(stats), (0, _match2.default)((0, _path3.default)(stats.publicPath), (0, _serve2.default)(options)));
};

var _fs = require('fs');

var _keyBy = require('lodash/keyBy');

var _keyBy2 = _interopRequireDefault(_keyBy);

var _flowRight = require('lodash/flowRight');

var _flowRight2 = _interopRequireDefault(_flowRight);

var _webpackAssets = require('webpack-assets');

var _webpackAssets2 = _interopRequireDefault(_webpackAssets);

var _path = require('path');

var _util = require('./match/util');

var _match = require('./match');

var _match2 = _interopRequireDefault(_match);

var _path2 = require('./match/path');

var _path3 = _interopRequireDefault(_path2);

var _serve = require('./serve');

var _serve2 = _interopRequireDefault(_serve);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var addIndexAssets = function addIndexAssets(assets, index) {
  if (typeof index === 'boolean') {
    return index ? addIndexAssets(assets, 'index.html') : {};
  }
  if (typeof index !== 'string') {
    throw new TypeError();
  }
  return assets.filter(function (asset) {
    return (0, _path.basename)(asset.url) === index;
  }).reduce(function (result, asset) {
    var _extends2;

    var entry = (0, _path.dirname)(asset.url);
    return _extends({}, result, (_extends2 = {}, _defineProperty(_extends2, entry, asset), _defineProperty(_extends2, entry + '/', asset), _extends2));
  }, {});
};

/**
 * Serve assets generated by webpack.
 * @param {Object} stats Webpack stats object.
 * @returns {Function} Herp.
 */
function asset(stats) {
  var _ref = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var _ref$index = _ref.index;
  var index = _ref$index === undefined ? false : _ref$index;

  var assets = (0, _webpackAssets2.default)(stats);
  var assetIndex = _extends({}, (0, _keyBy2.default)(assets, function (asset) {
    return asset.url;
  }), addIndexAssets(assets, index));
  return (0, _util.create)(function (req) {
    if (assetIndex[req.url]) {
      req.asset = assetIndex[req.url];
      return true;
    }
    return false;
  });
}

function request(stats) {
  var assets = (0, _webpackAssets2.default)(stats);
  return function (app) {
    var _request = app.request;

    return _extends({}, app, {
      request: function request(req, res) {
        req.assets = assets;
        _request(req, res);
      }
    });
  };
}

/**
 * @param {String} file Path to webpack stats object.
 * @param {Object} options Options passed to `serve`.
 * @returns {Function} Middleware.
 */
//# sourceMappingURL=assets.js.map