'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _parseurl = require('parseurl');

var _parseurl2 = _interopRequireDefault(_parseurl);

var _pathToRegexp = require('path-to-regexp');

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

exports.default = function (path) {
  return function (app) {
    var tokens = [].concat(_toConsumableArray(app.tokens || []), _toConsumableArray(path === '/' ? [] : (0, _pathToRegexp.parse)(path)));
    var regexp = (0, _pathToRegexp.tokensToRegExp)(tokens, { end: false });
    var keys = tokens.filter(function (t) {
      return (typeof t === 'undefined' ? 'undefined' : _typeof(t)) === 'object';
    });

    return _extends({}, app, {
      tokens: tokens,
      matches: (0, _util.combine)(app, function (req) {
        var params = regexp.exec((0, _parseurl2.default)(req).pathname);
        if (params) {
          req.path = params[0];
          req.params = req.params || {};
          keys.forEach(function (_ref, i) {
            var name = _ref.name;

            req.params[name] = params[i + 1];
          });
          return true;
        }
        return false;
      })
    });
  };
};
//# sourceMappingURL=path.js.map