'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.guard = exports.create = exports.combine = undefined;

var _isString = require('lodash/isString');

var _isString2 = _interopRequireDefault(_isString);

var _isRegExp = require('lodash/isRegExp');

var _isRegExp2 = _interopRequireDefault(_isRegExp);

var _isArray = require('lodash/isArray');

var _isArray2 = _interopRequireDefault(_isArray);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

var _some = require('lodash/some');

var _some2 = _interopRequireDefault(_some);

var _map = require('lodash/map');

var _map2 = _interopRequireDefault(_map);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var combine = exports.combine = function combine(app, match) {
  if (!app.matches) {
    return match;
  }
  return function (req, res) {
    return app.matches(req, res) && match(req, res);
  };
};

var create = exports.create = function create(match) {
  return function (app) {
    return _extends({}, app, {
      matches: combine(app, match)
    });
  };
};

var guard = exports.guard = function guard(hosts) {
  if ((0, _isString2.default)(hosts)) {
    return function (val) {
      return val === hosts;
    };
  } else if ((0, _isRegExp2.default)(hosts)) {
    return function (val) {
      return hosts.exec(val);
    };
  } else if ((0, _isFunction2.default)(hosts)) {
    return hosts;
  } else if ((0, _isArray2.default)(hosts)) {
    var _ret = function () {
      var guards = (0, _map2.default)(hosts, guard);
      return {
        v: function v(val) {
          return (0, _some2.default)(guards, function (x) {
            return x(val);
          });
        }
      };
    }();

    if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
  }
  throw new TypeError();
};
//# sourceMappingURL=util.js.map