'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _send = require('send');

var _send2 = _interopRequireDefault(_send);

var _parseurl = require('parseurl');

var _parseurl2 = _interopRequireDefault(_parseurl);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Server static files with `send`.
 * @param {Object} options Options based to `send`.
 * @returns {Function} Middleware function.
 */

exports.default = function (options) {
  return function (app) {
    var error = app.error;

    return _extends({}, app, {
      request: function request(req, res) {
        var url = (0, _parseurl2.default)(req);
        var path = req.path ? url.pathname.substr(req.path.length) : url.pathname;
        var stream = (0, _send2.default)(req, path, options);

        stream.on('error', error)
        // .on('directory', redirect)
        // .on('headers', headers)
        .pipe(res);
      }
    });
  };
};
//# sourceMappingURL=serve.js.map