'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

Object.defineProperty(exports, "__esModule", {
  value: true
});
/**
 * [default description]
 * @param {Function} thunkCreator Invoked with `app` to create the thunk. Must
 * return a function (the thunk) that returns the actual app. This Function
 * is invoked whenever the app is actually needed (i.e. when any of its event
 * methods are called, like `request`).
 * @returns {Function} Middleware function.
 */

exports.default = function (thunkCreator) {
  return function (app) {
    var thunk = thunkCreator(app);
    var thunkApp = {};
    Object.keys(app).forEach(function (key) {
      if (typeof app[key] === 'function') {
        thunkApp[key] = function () {
          var _thunk;

          return (_thunk = thunk.apply(undefined, arguments))[key].apply(_thunk, arguments);
        };
      }
    });
    return _extends({}, app, thunkApp);
  };
};
//# sourceMappingURL=thunk.js.map